set_import_module_path (".:" + get_import_module_path ());
#ifeval (_slang_version < 20000)
if (current_namespace () != "")
  import ("maplib", current_namespace ());
else
#endif
  import ("maplib");

private define convert_arrays (x, y)
{
   variable tx = typeof(x), ty = typeof(y);
   if (tx == Array_Type)
     {
	if (ty != Array_Type)
	  y = y[Int_Type[length(x)]];
     }
   else if (ty == Array_Type)
     x = x[Int_Type[length(y)]];

   return (x,y);
}

define maplib_project ()
{
   if (_NARGS != 3)
     throw UsageError, "(x,y)=maplib_project(map_info,lon,lat)";
   variable m, x, y;
   (m, x, y) = ();

   (x,y) = convert_arrays (x, y);

   return _maplib_project (m, x, y);
}

define maplib_deproject ()
{
   if (_NARGS != 3)
     throw UsageError, "(lon,lat)=maplib_deproject(map_info,x,y)";
   variable m, x, y;
   (m, x, y) = ();

   (x,y) = convert_arrays (x, y);

   return _maplib_deproject (m, x, y);
}

#ifexists provide
provide ("maplib");
#endif
